#include "stdafx.h"
#include "Config.h"
#include "Patcher.h"
#include "FileFormats/PKGFile.h"
#include "FileFormats/functions.h"
#include "fire666/Csocket.h"
#include "RSAMod.h"
#include "Stream.h"

char *STEAM_EXE_1 = NULL;
//char *STEAM_NETWORKKEY_HEADER = "30819d300d06092a864886f70d010101050003818b0030818702818100";//"\x30\x81\x9d\x30\x0d\x06\x09\x2a\x86\x48\x86\xf7\x0d\x01\x01\x01\x05\x00\x03\x81\x8b\x00\x30\x81\x87\x02\x81\x81\x00";

void ReplacePattern(char *filename, char *from, int fromlen, char *to, int tolen)
{
	CStream *str = new CStream(filename, false);
	int fsize = (INT32)str->GetSize();
	char *buf = new char[fsize];
	str->Read(buf, fsize);
	delete str;

	// find pattern
	fsize -= fromlen;
	for (int i=0 ; i<fsize ; i++)
	{
		if (memcmp(from, buf+i, fromlen) == 0)
			// replace pattern
			memcpy(buf+i, to, tolen);
	}

	// save changes
	fsize += fromlen;
	str = new CStream(filename, true);
	str->Write(buf, fsize);
	delete str;
}

void ReplaceResource(char *filename, char *section, char *name, int ID, char *to, UINT32 len)
{
	HANDLE hRes = BeginUpdateResourceA(filename, false);
	if (hRes == NULL)
		return;
	if (!UpdateResourceA(hRes, section, name, MAKELANGID(LANG_NEUTRAL,SUBLANG_NEUTRAL), to, len))
		return;
	if (EndUpdateResourceA(hRes, false) == NULL)
		return;
}

void PatchSteamEXE()
{
	if (STEAM_EXE_1 == NULL)
	{
		char *Port = GetConfigStr("Servers", "MDS_Port"),
			*IP = Csocket::IP2Str(Csocket::resolve(""));
		int len = 6 * (strlen(IP) + 1 + strlen(Port));
		STEAM_EXE_1 = new char[len];
		sprintf(STEAM_EXE_1, "%s:%s %s:%s %s:%s %s:%s %s:%s %s:%s", IP, Port, IP, Port, IP, Port, IP, Port, IP, Port, IP, Port);
	}

	char *filesDir = GetConfigStr("Servers", "filesPath"),
		FN[100], FN1[100], FN2[100];
	sprintf_s(FN, 100, "%sSteam_%i.pkg", filesDir, GetConfigInt("Config", "Steam"));
	sprintf_s(FN1, 100, "%sSteam_%i\\", filesDir, GetConfigInt("Config", "Steam"));
	CPKGFile *pkg = new CPKGFile(FN);
	pkg->Extract(FN1);

	// patching
	char *NK = GetNetworkKey();
	ReplaceResource(MakeStr(FN1, "SteamNew.exe"), "CONFIGDATA", "GENERALDIRECTORYSERVER_IPADDRPORTS", 0, 
		STEAM_EXE_1, strlen(STEAM_EXE_1));
	int PatternsCount = GetConfigInt("patterns", "Count");
	for (int i=0 ; i<PatternsCount ; i++)
	{
		char *from = GetConfigStr("patterns", "Header", i+1),
			*to  = GetConfigStr("patterns", "Replace", i+1);
		ReplacePattern(MakeStr(FN1, "SteamNew.exe"), from, strlen(from), to, strlen(to));
		delete from;
		delete to;
	}

	sprintf_s(FN2, 100, "%sSteam_%i.pkg.mst", filesDir, GetConfigInt("Config", "Steam"));
	pkg->Pack(FN1, FN, FN2);
	delete pkg;
}

void PatchSteamDLL()
{
	char *filesDir = GetConfigStr("Servers", "filesPath"),
		FN[100], FN1[100], FN2[100];
	sprintf_s(FN, 100, "%sSteamUI_%i.pkg", filesDir, GetConfigInt("Config", "SteamUI"));
	CPKGFile *pkg = new CPKGFile(FN);
	sprintf_s(FN1, 100, "%sSteamUI_%i\\", filesDir, GetConfigInt("Config", "SteamUI"));
	pkg->Extract(FN1);

	// patching
	ReplaceResource(MakeStr(FN1, "Steam.dll"), "CONFIGDATA", "GENERALDIRECTORYSERVER_IPADDRPORTS", 0, 
		STEAM_EXE_1, strlen(STEAM_EXE_1));
	int PatternsCount = GetConfigInt("patterns", "Count");
	for (int i=0 ; i<PatternsCount ; i++)
	{
		char *from = GetConfigStr("patterns", "Header", i+1),
			*to  = GetConfigStr("patterns", "Replace", i+1);
		ReplacePattern(MakeStr(FN1, "Steam.dll"), from, strlen(from), to, strlen(to));
		delete from;
		delete to;
	}

	sprintf_s(FN2, 100, "%sSteamUI_%i.pkg.mst", filesDir, GetConfigInt("Config", "SteamUI"));
	pkg->Pack(FN1, FN, FN2);
	delete pkg;
}

void PatchAll()
{
	PatchSteamEXE();
	PatchSteamDLL();
}