//========= Copyright  2010, fire64 LLC, All rights reserved. ============
//
// Purpose: 
//
// $NoKeywords: $
//=============================================================================
#include "..\stdafx.h"

#define MAXRECVSIZE 204800

typedef enum ESocketProtocol
{
	eSocketProtocolUnknown = 0,
	eSocketProtocolTCP = 1,
	eSocketProtocolUDP = 2,
	eSocketProtocolIP = 3,

} ESocketProtocol;

class Csocket
{
public:
	Csocket( ESocketProtocol protocol );
	~Csocket();

	//Socket Function
	int BindPort( int port );
	static unsigned long resolve(char *host);
	int SetAdr( sockaddr_in  new_addr );
	int SetAdr( char *ip, int port );
	int SetTimeOut( int settimeout );
	bool Connect( );
	bool Send( char *buff, int sizebuff = 0 );
	bool IfUseTimeOut();
	int Recv( char *recvbuff, int size = 0 );
	bool SendInt32(UINT32 buff, bool reverse = true);
	bool SendInt16(UINT16 buff, bool reverse = true);
	bool RecvInt32(UINT32 *buff, bool reverse = true);
	bool RecvInt16(UINT16 *buff, bool reverse = true);
	Csocket *AcceptConnect();
	bool ListenServer();
	ESocketProtocol GetCurentProtocol( );
	UINT32 GetIP();
	char *GetAddr();
	static char *IP2Str(UINT32 IP);

	static void init();
	static void deinit();

private:
	bool m_iftcp;
	bool m_usetimeout;
	timeval timeout;

	fd_set fd_read;
	fd_set fd_write;
	fd_set fd_error;

	sockaddr_in  dest_addr;
	SOCKET  current_sock;
};
